/* Опрос весов CAS CI-200 и CI-6000.
 * Весы сами передают данные.   
 * Для корректной работы скрипта необходимо, чтобы параметр F33 весов (выходной режим) должен быть установлен равным 1 (непрерывный режим).
 * Скорость обмена устанавливается в соответствии со значение параметра F32 установленного в весах.
 */


#include <time>
#include <string>
#include tracker
#include serial
#include CasCI

#pragma dynamic               256

#define WEIGHT_TAG            0
#define STATUS_TAG            1

#define SERIAL_PORT_LIBRA     SERIAL_PORT_1
#define LIBRA_ID              10
#define MAX_READ_ATTEMPT      5   /* Количество попыток чтения весов */

static ClearRxBuffer()
{
    new sb[32];   
    while (rsrecv(sb) != 0){}
}
/* Скрипт */
main()
{
  new bool:Valid = false
  new Weight
  new WeightPow;
  new Status;
  new Buff[32];
  new Len

  for(;;)
  {
    /* Читаем весы */
    Valid = false;
    if (rsopen(SB_AUTO, SERIAL_PORT_LIBRA) == true) /* Удалось открыть порт */
    {
        ClearRxBuffer();
        Len = LibraCiRead(SERIAL_PORT_LIBRA, Buff, sizeof(Buff));
        Valid = LibraCiParse22Byte(Buff, Len, Weight, WeightPow, Status)
        rsclose(SERIAL_PORT_LIBRA) /* Освобождаем порт  */
    }
    /* Запоминаем значения */
    settag(WEIGHT_TAG, Weight, Valid, WeightPow) /* Пишем вес в таг */
    settag(STATUS_TAG, Status, Valid)
    /* пауза */
    delay(1000);
  }
}
