/* Весы НВТ-1Н (Невские весы)
 * (c) Copyright 2021, GLONASSsoft
 * This file is provided as is (no warranties).
 */

#pragma library LibraNVT_1N

#include serial
#include string

/* Функция чтения периодических данных из порта */
stock NVT_1N_Read(SerialPort:port = SERIAL_PORT_0, Buff[], SizeBuff)
{
    new Len, Offs = 0;
    new BuffRead[8 * 3];  
    new pBuff = 0;
    
    Len = rsrecv(BuffRead, sizeof(BuffRead), 1000, 100, port); /* Читаем буфер */
    
    for (new i = 0; i < Len; i++)
    {
        if (BuffRead[i] == '=')
        {
            Offs = i;
            break;
        }
    }
    
    while ((pBuff < SizeBuff) && (Offs < Len))
    {
        Buff[pBuff++] = BuffRead[Offs++];
        if (BuffRead[Offs] == '=') break;
    }
    printf("Data len=%d", pBuff);
    return pBuff
}


stock bool:NVT_1N_Parse_Direct(DataBuff[], DataLen, &Weight, &WeightPow)
{
  new Value = 0;
  new Pow = 0;
  new bool:Negative = false;
  new bool:Dot = false;

  if (DataLen < 8) return false;
  /* Значение веса */
  for(new i = 0; i < DataLen; i++)
  {
    if (DataBuff[i] == '-') Negative = true;
    if (DataBuff[i] == '.') Dot = true;
    if ('0' <= DataBuff[i] <= '9')
    {
      Value = (Value * 10);
      Value += (DataBuff[i] - '0');
      if (Dot) Pow++;
    }
  }
  if (Negative) Value = -Value;
  Weight = Value;
  WeightPow = Pow;

  return true;
}

stock bool:NVT_1N_Parse_Back(DataBuff[], DataLen, &Weight, &WeightPow)
{
  new Value = 0;
  new Pow = 0;
  new bool:Negative = false;
  new bool:Dot = false;

  if (DataLen < 8) return false;
  /* Значение веса */
  for(new i = (DataLen - 1); i >= 0; i--)
  {
    if (DataBuff[i] == '-') Negative = true;
    if (DataBuff[i] == '.') Dot = true;
    if ('0' <= DataBuff[i] <= '9')
    {
      Value = (Value * 10);
      Value += (DataBuff[i] - '0');
      if (Dot) Pow++;
    }
  }
  if (Negative) Value = -Value;
  Weight = Value;
  WeightPow = Pow;

  return true;
}