/* Микросим М0601-Б
 * (c) Copyright 2020, GLONASSsoft
 * This file is provided as is (no warranties).
 */
 
 /* Получение данных */
static LibraM0601ReadBuff(Buff[], Size = sizeof(Buff), SerialPort:port = SERIAL_PORT_0)
{
    new Len, Offs = 0;
    new BuffRead[15 * 3];  
    new pBuff = 0;
    
    Len = rsrecv(BuffRead, _, 100, 100, port); /* Читаем буфер */
    for (new i = 0; i < Len; i++)
    {
        if (BuffRead[i] == 0x0A)
        {
            Offs = (i + 1);
            break;
        }
    }
    
    while ((pBuff < Size) && (Offs < Len))
    {
        Buff[pBuff++] = BuffRead[Offs++];
        if (BuffRead[Offs] == 0x0A) break;
    }
    printf("Data len=%d", pBuff);
    return pBuff    
}

/* Распарсивание данных */
static bool:LibraM0601Parse(DataBuff[], DataLen, &Weight, &WeightPow)
{
  new Value = 0;
  new Pow = 0;
  new bool:Negative = false;
  new bool:Dot = false;
  new Sb;

  if (DataLen != 14) return false;
      
  if ((DataBuff[2] == 0x45) && (DataBuff[3] == 0x72) && (DataBuff[3] == 0x72)) return false;// "Err"
  /* Значение веса */
  for(new i = 0; i < 7; i++)
  {
    Sb = DataBuff[2+i];
    switch(Sb)
    {
    case '-':
        Negative = true;
    case '.':
        Dot = true;
    case '0'..'9':
        {
            Value = (Value * 10);
            Value += (Sb - '0');
            if (Dot) Pow++;            
        }
    }
  }
  if (Negative) Value = -Value;
  Weight = Value;
  WeightPow = Pow;
  return true;
}

/* */
stock bool:LibraM0601Read(SerialPort:port = SERIAL_PORT_0, &Weight, &WeightPow)
{
    new bool:Valid = false
    new Buff[32];
    new Len    
    
    Len = LibraM0601ReadBuff(Buff, _, port);
    printf("M0601 read len=%d", Len);
    if (Len) 
    {
        Valid = LibraM0601Parse(Buff, Len, Weight, WeightPow);
        printf("M0601 Valid=%d,Weight = %d,Pow=%d", Valid, Weight, WeightPow);
    }
    return Valid;
}